using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_CRM._0_Modelos;
using Exferia_CRM.General;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Exferia_CRM._3_Vistas.Listados
{
    public class ABS_Listado_CRM_AccionesLineas : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_CRM_AccionesLineas()
        {
            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            //id
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRM_AccionesLineas_Listado_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_CRM_AccionesLineas_Listado_Modelo.id), "id", Enumerados.G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, true, false, "", null));

            //Numero Linea
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRM_AccionesLineas_Listado_Modelo.numeroLinea), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRM_AccionesLineas_Listado_Modelo.numeroLinea), "Nº Línea", Enumerados.G_ENUM_TIPOSDATOS.INT, false, 50, true, true, true, false, "", null));
            
            //Descripción
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRM_AccionesLineas_Listado_Modelo.descripcion), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRM_AccionesLineas_Listado_Modelo.descripcion), "Descripción", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 150, true, true, true, false, "", null));
            
            //Fecha
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRM_AccionesLineas_Listado_Modelo.fecha), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRM_AccionesLineas_Listado_Modelo.fecha), "Fecha", Enumerados.G_ENUM_TIPOSDATOS.DATETIME, false, 100, true, true, true, false, "", null));

            //Tipo Acción
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRM_AccionesLineas_Listado_Modelo.Accion), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRM_AccionesLineas_Listado_Modelo.Accion), "Tipo Acción", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 250, true, true, true, false, "", null));

            //Observaciones
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRM_AccionesLineas_Listado_Modelo.observaciones), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRM_AccionesLineas_Listado_Modelo.observaciones), "Observaciones", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 250, true, true, true, false, "", null));
        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_CRM_ACCIONESCABECERA);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_CRM_ACCIONESCABECERA;
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_CRM_AccionesLineas_Listado_Modelo.numeroLinea);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
